<?php

namespace STM\Competition\Playoff\Round;

use STM\Libs\Generators\Playoff\PlayoffException;
use STM\Libs\Generators\Playoff\PlayoffDuelParticipant;
use STM\Libs\Generators\Playoff\PlayoffGenerator;
use \GetterOfTestingInstances;
use \Exception;
use STM\StmFactory;


/**
 * Test class for PlayoffRoundValidator.
 * Generated by PHPUnit on 2012-02-05 at 20:16:08.
 * @group competition_playoff
 */
class PlayoffRoundValidatorTest extends \PHPUnit_Framework_TestCase {

    /** @var array */
    private $next_round_data;

    protected function setUp() {
        $playoff = GetterOfTestingInstances::getPlayoff();
        if (!$playoff) {
            return;
        }
            
        if ($playoff->getPlayedRounds() == 0) {
            $items = $playoff->getTeamsWithSeeded();
        } else {
            $items = StmFactory::find()->PlayoffSerie->findByPlayoffRound($playoff, $playoff->getPlayedRounds());
        }
        try  {            
            $generator = PlayoffGenerator::create($items);
            $this->next_round_data = array(
                'playoff' => $playoff,
                'round' => $playoff->getPlayedRounds() + 1,
                'matches' => $generator->generateRound()
            );
        } catch (PlayoffException $e) {            
            $this->next_round_data = null;
        }        
        PlayoffRoundValidator::init();
    }
    
    public function test_bad_arguments() {
        // argument must be array('playoff' => ..., 'round' => ...., 'matches' => ...);
        $this->assert_bad_arguments(null);
        $this->assert_bad_arguments(new Exception());
        $this->assert_bad_arguments(array('playoff' => 1, 'round' => 22, 'match' => 2));
    }

    public function test_bad_playoff() {
        // first argument must be instanceof Playoff
        $this->assert_bad_argument('playoff', 1);
        $this->assert_bad_argument('playoff', null);
    }

    public function test_bad_matches() {
        if (!$this->next_round_data) {
            return;
        }
        // if round is >= 2 then all matches home,away == PlayoffSerie
        $last_match = array_pop($this->next_round_data['matches']);
        $last_match['home'] = new PlayoffDuelParticipant(1, 1);
        $this->next_round_data['matches'][] = $last_match;
        $this->assert_bad_argument('matches', $this->next_round_data['matches']);
        // if round is >= 2 then all PlayoffSerie must have winner
        $last_match = array_pop($this->next_round_data['matches']);
        $last_match['home']->team = $this->get_unfinished_serie();
        $this->next_round_data['matches'][] = $last_match;
        $this->assert_bad_argument('matches', $this->next_round_data['matches']);
        // third argument must be array
        $this->assert_bad_argument('matches', 1);
        $this->assert_bad_argument('matches', null);
        // array - keys are home, away and instanceof PlayoffDuelParticipant
        $this->assert_bad_argument('matches', array('home' => 1, 'away' => 2));
        $this->assert_bad_argument('matches', array('home' => 1, 'a' => 2));
    }

    public function test_bad_round() {
        if (!$this->next_round_data) {
            return;
        }
        // second argument must be number <1, Playoff::getMaxRound>, but maximum is 7 AND it must be Playoff::getPlayedRounds()+1
        $this->assert_bad_argument('round', -1);
        $this->assert_bad_argument('round', $this->next_round_data['playoff']->getMaxRound() + 1);
        $this->assert_bad_argument('round', $this->next_round_data['playoff']->getPlayedRounds() + 2);
    }

    public function test_check_generated_round() {
        if (!$this->next_round_data) {
            return;
        }
        // selected teams maybe dont have all series finished
        $test = PlayoffRoundValidator::checkGeneratedRound($this->next_round_data);
        if ($test) {
            parent::assertTrue($test);
        }
    }    

    private function assert_bad_argument($key, $value) {
        $this->next_round_data[$key] = $value;
        $this->assert_bad_arguments($this->next_round_data);
    }

    private function assert_bad_arguments($data) {
        PlayoffRoundValidator::init();
        parent::assertFalse(PlayoffRoundValidator::checkGeneratedRound($data));
        PlayoffRoundValidator::init();
    }

    private function get_unfinished_serie() {
        $playoffs = GetterOfTestingInstances::find_playoffs();
        foreach ($playoffs as $playoff) {
            $series = StmFactory::find()->PlayoffSerie->findByPlayoff($playoff);
            foreach ($series as $serie) {
                if (!$serie->isFinished($playoff)) {
                    return $serie;
                }
            }
        }
        return false;
    }

}

?>
